function toymodel(T1,T2,T3,T4,T5,T6,lagshow,t1blank, lagtype, display)

global Items  Blaster  
global   BlasterHistory ShutoffsHistory lags SOA lagmultiply name blastersize  Strongmask EEGp3 EEGn2pc
global T1t1 T1t2 T2t1 T2t2 Tokencomplete Leaks Itemblastable Binders BindersboundHistory BindersboundHistory2 Types InputHistory Bindersbound BinderHistory  Leaks Bleaks Bindersbound bdelay
global order orderperf boundtime TraceHistory BinhibHistory  justbound fluxdurflag TypesHistory justt1delay lags numtargs justt2delay
global oldmodel

%toymodel(T1,T2,T3,T4,T5,T6,lagshow,t1blank, lagtype, display)

%T1-T6: strength of targets
%lagshow: show activation for a particular lag (condition), 0 disables
%t1blank: put blanks after T1 and T2   [x y]
%           x = 1: T1+1 blank
%           x = 2: T1 completely unmasked
%           y:  same for T2
%lagtype: calls getlags.m using this value to determine what set of
%           conditions to use
%display: verbose flag


if(length(Strongmask) == 0)
    Strongmask = 0;
end


steps  = 300;  %steps per trial

%History Variables for storing simulation results
InputHistory = zeros(8,steps,6);
TypeHistory = zeros(8,steps,6);
BlasterHistory = zeros(8,steps,1);      
BinderHistory = zeros(8,steps,6,6,2);  %Binding Pool Gates
TraceHistory = zeros(8,steps,6,6,2);   %Binding Pool Trace
BinhibHistory = zeros(8,steps,6);      %gateshutoff nodes

BindersboundHistory2 = zeros(8,6,6,steps);



%Parameters
dt = 10;   %Number milliseconds per timestep
typethresh = 2;  %threshold for Types exciting  BP Gates
blasterthresh = 1.7;  %threshold of Blaster activation


blastersuppress = 1.5;  %suppression of blaster

mixedreportparameter = 1;   %used to simulate Mark N.'s mixed report effect, set to 1 to disable
mixedreportT2parameter = 1;  %used to simulate Mark N.'s mixed report effect, set to 1 to disable
%blastersuppress = 1.5 *mixedreportparameter ;  %suppression of blaster


bdecay= .85;        %decay rate of blaster node
inhib = .045;   %lateral inhibition within the types
blastersize = 3.5;  %the amount of blaster amplification
Leak = .7;  %Type Node decay rate
Binderbias = [-.005, -.01,-.015,-.02,-.025,-.03];  %the bias of the BP Gate nodes
Bleak =.93;   %BP Gate Node decay rate
bindweight = .014;  %Rate at which BP Tokens accrue activation
recurrence = .105*4;   %recurrent feedback of BP Gates to Types
binderinhibthresh = 1.2;  %gate shutoffnode threshold
distractorsuppress = .12;   % decay rate when another distractor is on
passivedecayrate = 0.0001;     % decay rate of unmasked presentation (iconic memory)
binderexcite = .25;   %Rate at which Types excite Gate nodes
t1time = 400;   % T1 onset
Iconictime = 350; %ms of time that an unmasked target stays active
hangtime = 3;  % timesteps an input node persists
 binderthresh = 10;        %Gate node threshold
   binhibrecurrent = 100;  %Gate Shutoff node recurrence
 TypeRBthreshold = 4;  %Type nodes have to get below this threshold to allow a repetition to start. 
 

 
    
 
%%%%%%%%%%%%%%%%%%
%input patterns

getlags(lagtype,display);
T1dur = SOA/dt;
T2dur = SOA/dt;
T3dur = SOA/dt;
T4dur = SOA/dt;
T5dur = SOA/dt;
T6dur = SOA/dt;


%%%%%%%%%%%%%%%%%%
% Step through the conditons


for(lag =1:size(lags,1))

   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %Pre-Trial initiatilization

    T1step = lags(lag,1)* (SOA/dt) + (t1time/dt);
    T2step = lags(lag,2)* (SOA/dt) + (t1time/dt) ;
    T3step = 5000;
    T4step = 5000;
    T5step = 5000;
    T6step = 5000;
    if(numtargs >2)
         T3step = lags(lag,3)* (SOA/dt) + (t1time/dt) ;
    end
    if(numtargs >3)
         T4step = lags(lag,4)* (SOA/dt) + (t1time/dt) ;
    end
     if(numtargs >4)
         T5step = lags(lag,5)* (SOA/dt) + (t1time/dt) ;
    end
      if(numtargs >5)
         T6step = lags(lag,6)* (SOA/dt) + (t1time/dt) ;
      end
      
      
      if(T1step < 0)
          T1step = 5000;
      end
      if(T2step < 0)
          T2step = 5000;
      end
     
      
      if(T3step < 0)
          T3step = 5000;
      end
      if(T4step < 0)
          T4step = 5000;
      end
      if(T5step < 0)
          T5step = 5000;
      end
      if(T6step < 0)
          T6step = 5000;
      end
      
      
      
    %%%%%%%%%%%%%%%%%%
    %  Initialize Nodes
    Types = zeros(6,1);         %Type Nodes
    Tokens = zeros(6,1);
    Binders = zeros(6,6,2);    %BP Gate Nodes
    Bindersbound = zeros(6,6,6);  %BP Trace Nodes
    boundtime = zeros(6,6,6);    %time at which binding completed
    Bound = zeros(6,6);         %indicates that a binding has completed
    binderinhib = zeros(6,1);
    justbound = zeros(6,6);
    binderinhib = zeros(6,1);
    inhibthresh = binderthresh + .1;
           
    
    
    %%%%%%%%%%%%%%%%%%
    %	Other variables to initialize at the start of a trial
    blasting = 0;
    Blaster = 0;
    t1add = 0;   
    t2add = 0;
    t3add = 0;
    t4add = 0;
    t5add = 0;
    t6add = 0;
    if(justt1delay > 0)  %for Vince, we want the bdelay to return to normal after the first item
        bdelay = 0;
    end
     if(justt2delay > 0)  %for Vince , we want the bdelay to go up to 3 after the first item
        bdelay = 3;
    end

    %%%%%%%%%%%%%%%%%%
    %start the RSVP trial
    for(step = 1:steps)
        
        inputnow = zeros(6,1);
        onsince = zeros(6,1);
        on = max(0,step-T1step);
         
        
      %  if(on ==(t1time/dt)+4 & justt1delay)  % are we well into T1
      %  processing?  change the bdelay back to 3 if this is a special case
      %   OLD CODE... ERRONEOUS
      %      bdelay = 3;
      %   end
        
         
        if(on == T1dur+ 50/dt & justt1delay)  % are we well into T1 processing?  change the bdelaystep back to 3 if this is a special case
            bdelay = 3;
        end

        if(on == T1dur + 50/dt & justt2delay)  % are we well into T1 processing?  change the bdelaystep to 0 if this is a special case
            bdelay = 0;
        end
    
         
         
         
        if(on >0  & on < (SOA/dt+hangtime))
            inputnow(1) = 1;
           
        end
         onsince(1) = on;

        on = max(0,step-T2step);
        if(on >0  & on < (SOA/dt+hangtime))
            inputnow(2) = 1;
         
        end
           onsince(2) = on;  
        on = max(0,step-T3step);
        if(on >0  & on < (SOA/dt+hangtime))
            inputnow(3) = 1;
             
        end
        onsince(3) = on; 
        on = max(0,step-T4step);
        if(on >0  & on < (SOA/dt+hangtime))
            inputnow(4) = 1;
             
        end
        onsince(4) = on; 
        on = max(0,step-T5step);
        if(on >0  & on < (SOA/dt+hangtime))
            inputnow(5) = 1;
             
        end
        onsince(5) = on; 
        on = max(0,step-T6step);
        if(on >0  & on < (SOA/dt+hangtime))
            inputnow(6) = 1;
            
        end
          onsince(6) = on;
       
  
        
        on = max(0,step-T1step);  %past t1 onset?
        on2 = max(0,step-T2step);   %past t2 onset?
        
       
      
        if(inputnow(1))
            t1add = T1;
        elseif(t1blank(1,1)==2 & sum(inputnow(2:6)) ==0 & onsince(1) > 0 & onsince(2) < 1)  %infinite blanks after T1
            t1add = T1;
           % t1add = max(t1add-passivedecayrate,0);
        elseif(t1blank(1,1)==1 & onsince(1) <= SOA/dt*2+hangtime& sum(inputnow(2:6)) ==0)  %normal T1+1 blank
            t1add = max(t1add-passivedecayrate,0);
        else
            t1add = max(t1add-distractorsuppress,0);
        end

        if(onsince(1) > SOA/dt+(Iconictime/dt))    %iconic memory cutoff
            t1add = 0;
        end



        if(inputnow(2))
            t2add = T2;
        elseif(t1blank(1,2)==2& sum(inputnow(3:6))+inputnow(1) ==0)   % infinite blanks after T2
            t2add = max(t2add-passivedecayrate,0);
        elseif(t1blank(1,2)==1 & onsince(2) <= SOA/dt*2+hangtime)  %normal T2+1 blank
            t2add = max(t2add-passivedecayrate,0);
        elseif(lagtype ==6 & lag ==3 & onsince(2) < SOA/dt*2 +hangtime) %special case for the LLDLL case.
            t2add = max(t2add-passivedecayrate,0);
        else
            t2add = max(t2add-distractorsuppress,0);
        end
        if(onsince(2) > SOA/dt+(Iconictime/dt))  %iconic memory cutoff
            t2add = 0;
        end


        if(inputnow(3))
            t3add = T3;
        elseif( Strongmask ==0 | inputnow(4))
            t3add = max(t3add-distractorsuppress,0);
        else
            t3add = max(t3add-passivedecayrate,0);
            
        end
        
        if(onsince(3) > SOA/dt+(Iconictime/dt))
            t3add = 0;
        end
        

        if(inputnow(4))
            t4add = T4-Strongmask * .15;
        else
            t4add = max(t4add-distractorsuppress,0);
        end

         if(inputnow(5))
            t5add = T5;
        else
            t5add = max(t5add-distractorsuppress,0);
        end

        if(inputnow(6))
            t6add = T6;
        else
            t6add = max(t6add-distractorsuppress,0);
        end


        
        %%%%%%%%%%%%%%%%%%%%%%%%%%
        %Feed the activation into the input nodes
        
        %T1 node is complicated in cases of repetition
        %The Repetition Case      For lags 2 and 4
        if(lagtype==7 & (lag ==2 | lag ==4))
            Additions(1) = t1add+ t4add;
        else
            Additions(1) = t1add;
        end

        if(lagtype==7 & (lag ==2 | lag ==4))
            Additions(4) = 0;
        else

            Additions(4) = t4add;
        end

        %%%%%%%%%%%%%%%%%%%%%%%
        % other type nodes are simpler.
        Additions(2) = t2add*mixedreportT2parameter;
        Additions(3) = t3add;
        Additions(5) = t5add;
        Additions(6) = t6add;
        Additions2 = Additions;   %input to the blaster
        if(blasting)
            Additions2 = Additions * blastersize/2 ;
            Additions = Additions * blastersize;
        end
        
%        Additions2= Additions2 *mixedreportparameter;

        %%%%%%%%%%%%
        %compute the blaster activation
%        bsuppress =         max(max(Binders(:,:,1)))>2 ;
if(oldmodel)       
bsup = sum(sum(max(0,Binders(1:4,1:4,1))));   %for the 4 target version
else
    bsup = sum(sum(max(0,Binders(:,:,1))));
end   
        
        bsuppress = (bsup*.04)/(bsup*.04+1)*blastersuppress;
        Blaster = Blaster*bdecay + sum(Additions2) - bsuppress;
        BlasterHistory(lag,step,1) = Blaster;
        
        %%%%%%%%%%%
        %use bdelay and history to determine if blaster should be outputing
        %on this time step
        if(step > bdelay)
            if (BlasterHistory(lag,step-bdelay) > blasterthresh)
                blasting = 1;
            else
                blasting = 0;
            end
        end


       %now compute activations
        for(i = 1:6)
            Types(i) = Types(i) * Leak + Additions(i) +max(max(0,min(8,Binders(i,1:6,1))))*recurrence -   sum(max(0,Types))*inhib;
            Binders(i,1:6,1) = min(1000,Binders(i,1:6,1)*Bleak + max(0,Types(i)-typethresh)*binderexcite + Binderbias(1,1:6));
         
            if(binderinhib(i) > binderinhibthresh)  %gate shutoff nodes
                Binders(i,:) = 0;
            end

            if(Types(i) > 0)
                for(j = 1:6)                              
                    if(max(Bindersbound(:,j,1)) > binderthresh)   %An active trace node for token j shuts off all gate nodes
                        Binders(:,j) = 0;                        
                    end
                    Bindersbound(i,j,1) = Bindersbound(i,j ,1) + max(0,Binders(i,j,1))*bindweight;   %compute trace node activation
                    if(Bindersbound(i,j,1) > binderthresh)       %If a trace node above is above threshold, set off a gate shutoff node                               
                        Bindersbound(i,j,1) = 100;
                        Binders(:,j) = 0;
                        justbound(i,j) = justbound(i,j) + 1;
                        if(justbound(i,j) ==1)
                            Binders(i,:) = 0;
                            Bindersbound(i,:,1) =   max(0,Bindersbound(i,:,1) -20);  %inhibit all traces, but not enough to kill the active one
                        end
                        Bindersbound(i,j,1) = 100;

                    end
                end
            end
         
            %%%%%%%%%%%%%%%%%%%%%
            %Gateshutoff nodes
            
            %This is the pulse of activation that kicks a gate shutoff node
            %into its attractor
            inhibblast = max(justbound(i,:)==1);
            
            btsuppress = max(Types(i) >TypeRBthreshold);
            binderinhib(i) = binderinhib(i) * Leak + min(.001, max(0,(binderinhib(i)-binderinhibthresh)))*binhibrecurrent + inhibblast *1 + btsuppress*.3;
            if(binderinhib(i) > binderinhibthresh)   %if active, shut off the gate nodes for Type i
                Binders(i,:) = 0;
            end

        end

        %record this trial in the history 
        InputHistory(lag,step,1:6) = reshape(Additions,[1,1,6]);
        BinderHistory(lag,step,1:6,1:6,1:2) = reshape(Binders(:,:,:),[1,1,6,6,2]);
        TraceHistory(lag,step,1:6,1:6,1:1) = reshape(Bindersbound(:,:,1),[1,1,6,6,1]);
        TypesHistory(lag,step,1:6) = reshape(Types,[1,1,6]);
        BinhibHistory(lag,step,1:6) = reshape(binderinhib,[1,1,6]);
        BindersboundHistory(lag,:,:,1) = reshape(Bindersbound(:,:,1),[1,6,6,1]);
        BindersboundHistory2(lag,:,:,step) = reshape(Bindersbound(:,:,1),[1,6,6,1]);

        EEGp3(lag,step) =   sum(sum(sum(Binders)))+sum(Types);
        %this line computes the P3 for T2 alone
        % EEGp3(lag,step) =   sum(sum(sum(Binders(2,:,1))))+sum(Types(2,:));


        for(locs = 1:1)
            EEGn2pc(lag,step,locs) =  Blaster(locs);
        end
        
        
    end  %step



end  %lag

BindersboundHistory(1,1,1,6) = 0;

%display a figure showing activation in a particular condition

if(lagshow > 0)

    TypesHistory(:,:,6) =  TypesHistory(:,:,6);
    TypesHistory(:,:,5) =  TypesHistory(:,:,5);
    TypesHistory(:,:,4) =  TypesHistory(:,:,4);
    TypesHistory(:,:,3) =  TypesHistory(:,:,3);
    TypesHistory(:,:,2) =  TypesHistory(:,:,2);
    TypesHistory(:,:,1) =  TypesHistory(:,:,1);

    figure('Color',   [.7 .7 .7]);
    
    window = axes;
    set(window,'OuterPosition',[.08,.01,.99,.99]);
    
    lag = lagshow
    
    
    plot(TypesHistory(lag,:,1),'r','LineWidth',2)
    set(gca,'NextPlot','add')

    plot(TypesHistory(lag,:,2),'y','LineWidth',2)
    plot(TypesHistory(lag,:,3),'b','LineWidth',2)
    plot(TypesHistory(lag,:,4),'g','LineWidth',2)
    plot(TypesHistory(lag,:,5),'m','LineWidth',2)
    plot(TypesHistory(lag,:,6),'c','LineWidth',2)
    
    plot(BinderHistory(lag,:,1,3,1)/6-15)
    
   
    InputHistory = InputHistory -8;
    plot(InputHistory(lag,:,1),'r','LineWidth',2)
    plot(InputHistory(lag,:,2),'g','LineWidth',2)
    plot(InputHistory(lag,:,3),'b','LineWidth',2)
    plot(InputHistory(lag,:,4),'g','LineWidth',2)
    plot(InputHistory(lag,:,5),'m','LineWidth',2)
    plot(InputHistory(lag,:,6),'c','LineWidth',2)

    textcolor = [.3 .0 0];
    
    uicontrol('ForegroundColor',textcolor,'BackgroundColor',[.7 .7 .7],'FontSize',20,'Style','text','Units','Normalized','String',sprintf('Types'),'Position', [.01 .45 .13 .1],'HorizontalAlignment', 'Left');
    uicontrol('ForegroundColor',textcolor,'BackgroundColor',[.7 .7 .7],'FontSize',20,'Style','text','Units','Normalized','String',sprintf('Inputs'),'Position', [.01 .3 .13 .1],'HorizontalAlignment', 'Left');
    uicontrol('ForegroundColor',textcolor,'BackgroundColor',[.7 .7 .7],'FontSize',20,'Style','text','Units','Normalized','String',sprintf('Blaster'),'Position', [.01 .15 .13 .1],'HorizontalAlignment', 'Left');
    uicontrol('ForegroundColor',textcolor,'BackgroundColor',[.7 .7 .7],'FontSize',20,'Style','text','Units','Normalized','String',sprintf('Time (ms)'),'Position', [.5 .02 .25 .05],'HorizontalAlignment', 'Left');

    
    h = get(gca,'Children');
    plot(BlasterHistory(lag,:,1)/5-15,'LineWidth',3);

    y = get(gca,'YLim');
    set(gca,'YLim',[-20 y(2)]);

    xticks = [0 50 100 150 200 250 300 350 400];
    s = sprintf('%d|',xticks*dt);
    set(gca,'XTick',xticks);
    set(gca,'XTickLabel',s);
    
    
    yticks = [-20 -15 -10 -8 0 5 10 15 20];
    yticklabs = '-5|0|5|0|0|5|10|15|20';
    set(gca,'YTick',yticks);
    set(gca,'YTickLabel',yticklabs);
    a = fopen(sprintf('toylag%d.xl',lag),'w');

    fprintf(a,'\n');
    fclose(a);
end

